#undef NDEBUG

#include "../drvif.h"

extern unsigned activate_smmu ;

#define COND_OPEN_STACK(base_pointer, offset, size,             \
            comment, when, ro)                                  \
    do {                                                        \
        if ( (activate_smmu) & (when) )                         \
        {                                                       \
            int no_space_in_table = HW_OPEN_STACK((base_pointer),\
                    (offset), (size), (comment), (ro));         \
            assert (no_space_in_table);                         \
        }                                                       \
    } while(0)

#define COND_CLOSE_STACK(when)                                  \
    do {                                                        \
        if ( (activate_smmu) & (when) )                         \
        {                                                       \
            HW_CLOSE_STACK () ;                                 \
        }                                                       \
    } while(0)

#define COND_OPEN_STACK_R1(offset,size,when)                                \
        do {                                                                \
            int base_pointer ;                                              \
            asm volatile ( "addik %0, r1, 0\n" : "=r"(base_pointer) ) ;     \
            COND_OPEN_STACK( (void *) (base_pointer), (offset) , (size),    \
                    "stack" , (when) , 0 ) ;                                \
        } while ( 0 )


